!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #################################################################################
SUBROUTINE DEALLOC_TEB_n
!     #################################################################################
!
!!****  *DEALLOC_TEB_n * - Deallocate all arrays
!!
!!    PURPOSE
!!    -------
!
!!**  METHOD
!!    ------
!!
!!    REFERENCE
!!    ---------
!!      
!!
!!    AUTHOR
!!    ------
!!     V. Masson 
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004
!!      G. Pigeon   09/2012: deallocate ROUGH_WALL/ROUGH_ROOF
!!      G. Pigeon   10/2012: deallocate BEM variables
!!------------------------------------------------------------------
!

!
USE MODD_TEB_n,      ONLY : LCOVER, XCOVER, XZS,                                     &
                              XH_TRAFFIC, XLE_TRAFFIC, XH_INDUSTRY, XLE_INDUSTRY,    &
                              XZ0_TOWN, XBLD, XGARDEN, XROAD_DIR, XGREENROOF,        &
                              XBLD_HEIGHT, XWALL_O_HOR, XCAN_HW_RATIO,               &
                              XROAD_O_GRND, XGARDEN_O_GRND, XWALL_O_GRND,            &
                              XALB_ROOF, XEMIS_ROOF, XHC_ROOF,XTC_ROOF, XD_ROOF,     &
                              XALB_ROAD, XEMIS_ROAD, XHC_ROAD,XTC_ROAD, XD_ROAD,     &
                              XALB_WALL, XEMIS_WALL, XHC_WALL,XTC_WALL, XD_WALL,     &
                              XSVF_ROAD, XSVF_WALL, TSNOW_ROOF, TSNOW_ROAD,          &
                              NROOF_LAYER, NROAD_LAYER, NWALL_LAYER,                 &
                              XT_ROOF, XT_ROAD, XT_WALL_A, XT_WALL_B,                &
                              XAC_ROOF, XAC_ROAD, XAC_WALL, XAC_TOP,                 &
                              XAC_ROOF_WAT, XAC_ROAD_WAT,                            &
                              XQSAT_ROOF, XQSAT_ROAD, XDELT_ROOF, XDELT_ROAD, &
                              XROUGH_ROOF, XROUGH_WALL
USE MODD_TEB_GRID_n, ONLY : XGRID_PAR, XLAT, XLON, XMESH_SIZE
USE MODD_CH_TEB_n,   ONLY : XDEP, CCH_NAMES, CSV
!
USE MODD_DATA_TEB_n, ONLY : XPAR_Z0_TOWN, XPAR_BLD, XPAR_ALB_ROOF,         &
                              XPAR_EMIS_ROOF, XPAR_HC_ROOF, XPAR_TC_ROOF,  &
                              XPAR_D_ROOF, XPAR_ALB_ROAD, XPAR_EMIS_ROAD,  &
                              XPAR_HC_ROAD, XPAR_TC_ROAD, XPAR_D_ROAD,     &
                              XPAR_ALB_WALL, XPAR_EMIS_WALL, XPAR_HC_WALL, &
                              XPAR_TC_WALL, XPAR_D_WALL, XPAR_BLD_HEIGHT,  &
                              XPAR_WALL_O_HOR,                             &
                              XPAR_H_TRAFFIC, XPAR_LE_TRAFFIC,             &
                              XPAR_H_INDUSTRY, XPAR_LE_INDUSTRY ,          &
                              XPAR_GARDEN, NPAR_BLDTYPE,                   &
                              XPAR_ROAD_DIR, NPAR_USETYPE, NPAR_BLD_AGE,   &
                              NPAR_BLDCODE,                                &
                              XPAR_ROUGH_ROOF, XPAR_ROUGH_WALL
!
USE MODD_BEM_n,      ONLY : XHC_FLOOR, XTC_FLOOR, XD_FLOOR, XTCOOL_TARGET,           &
                            XTHEAT_TARGET, XF_WASTE_CAN, XEFF_HEAT, XTI_BLD,         &
                            XT_FLOOR, XT_MASS, XQIN, XQIN_FRAD, XSHGC, XSHGC_SH,     &
                            XU_WIN, XGR, XINF, CHEAT_COIL,                           &
                            XF_WATER_COND, XAUX_MAX, XQIN_FLAT,                      &
                            XHR_TARGET, XT_WIN2, XQI_BLD, XV_VENT, XCAP_SYS_HEAT,    &
                            XCAP_SYS_RAT, XT_ADP, XM_SYS_RAT, XCOP_RAT, XT_WIN1,     &
                            XALB_WIN, XABS_WIN, XT_SIZE_MAX, XT_SIZE_MIN, XUGG_WIN,  &
                            LSHADE, CNATVENT, LSHAD_DAY, LNATVENT_NIGHT,             &
                            XN_FLOOR, XGLAZ_O_BLD, XMASS_O_BLD, XFLOOR_HW_RATIO,     &
                            XF_FLOOR_MASS, XF_FLOOR_WALL, XF_FLOOR_WIN,              &
                            XF_FLOOR_ROOF, XF_WALL_FLOOR, XF_WALL_MASS,              &
                            XF_WALL_WIN, XF_WIN_FLOOR, XF_WIN_MASS, XF_WIN_WALL,     &
                            XF_MASS_FLOOR, XF_MASS_WALL, XF_MASS_WIN, &
                            XTRAN_WIN, XFLOOR_HEIGHT
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*      0.1    declarations of arguments
!
!
!*      0.2    declarations of local variables
!
!-------------------------------------------------------------------------------------
!

REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('DEALLOC_TEB_N',0,ZHOOK_HANDLE)
IF (ASSOCIATED(LCOVER ))  DEALLOCATE(LCOVER )
IF (ASSOCIATED(XCOVER ))  DEALLOCATE(XCOVER )
IF (ASSOCIATED(XZS    ))  DEALLOCATE(XZS    )
!
!-------------------------------------------------------------------------------------
!
IF (ASSOCIATED(XGRID_PAR )) DEALLOCATE(XGRID_PAR )
IF (ASSOCIATED(XLAT      )) DEALLOCATE(XLAT      )
IF (ASSOCIATED(XLON      )) DEALLOCATE(XLON      )
IF (ASSOCIATED(XMESH_SIZE)) DEALLOCATE(XMESH_SIZE)
!
!-------------------------------------------------------------------------------------
!
IF(ASSOCIATED(XZ0_TOWN     )) DEALLOCATE(XZ0_TOWN     )
IF(ASSOCIATED(XALB_ROOF    )) DEALLOCATE(XALB_ROOF    )
IF(ASSOCIATED(XEMIS_ROOF   )) DEALLOCATE(XEMIS_ROOF   )
IF(ASSOCIATED(XALB_ROAD    )) DEALLOCATE(XALB_ROAD    )
IF(ASSOCIATED(XEMIS_ROAD   )) DEALLOCATE(XEMIS_ROAD   )
IF(ASSOCIATED(XALB_WALL    )) DEALLOCATE(XALB_WALL    )
IF(ASSOCIATED(XEMIS_WALL   )) DEALLOCATE(XEMIS_WALL   )
IF(ASSOCIATED(XBLD         )) DEALLOCATE(XBLD         )
IF(ASSOCIATED(XGARDEN      )) DEALLOCATE(XGARDEN      )
IF(ASSOCIATED(XROAD_DIR    )) DEALLOCATE(XROAD_DIR    )
IF(ASSOCIATED(XGREENROOF   )) DEALLOCATE(XGREENROOF   )
IF(ASSOCIATED(XBLD_HEIGHT  )) DEALLOCATE(XBLD_HEIGHT  )
IF(ASSOCIATED(XWALL_O_HOR  )) DEALLOCATE(XWALL_O_HOR  )
IF(ASSOCIATED(XCAN_HW_RATIO)) DEALLOCATE(XCAN_HW_RATIO)
IF(ASSOCIATED(XROAD_O_GRND))  DEALLOCATE(XROAD_O_GRND)
IF(ASSOCIATED(XGARDEN_O_GRND))DEALLOCATE(XGARDEN_O_GRND)
IF(ASSOCIATED(XWALL_O_GRND))  DEALLOCATE(XWALL_O_GRND)
IF(ASSOCIATED(XH_TRAFFIC   )) DEALLOCATE(XH_TRAFFIC   )
IF(ASSOCIATED(XLE_TRAFFIC  )) DEALLOCATE(XLE_TRAFFIC  )
IF(ASSOCIATED(XH_INDUSTRY  )) DEALLOCATE(XH_INDUSTRY  )
IF(ASSOCIATED(XLE_INDUSTRY )) DEALLOCATE(XLE_INDUSTRY )
IF(ASSOCIATED(XHC_ROOF )) DEALLOCATE(XHC_ROOF )
IF(ASSOCIATED(XTC_ROOF )) DEALLOCATE(XTC_ROOF )
IF(ASSOCIATED(XD_ROOF  )) DEALLOCATE(XD_ROOF  )
IF(ASSOCIATED(XHC_ROAD )) DEALLOCATE(XHC_ROAD )
IF(ASSOCIATED(XTC_ROAD )) DEALLOCATE(XTC_ROAD )
IF(ASSOCIATED(XD_ROAD  )) DEALLOCATE(XD_ROAD  )
IF(ASSOCIATED(XHC_WALL )) DEALLOCATE(XHC_WALL )
IF(ASSOCIATED(XTC_WALL )) DEALLOCATE(XTC_WALL )
IF(ASSOCIATED(XD_WALL  )) DEALLOCATE(XD_WALL  )
IF(ASSOCIATED(XSVF_ROAD)) DEALLOCATE(XSVF_ROAD)
IF(ASSOCIATED(XSVF_WALL)) DEALLOCATE(XSVF_WALL)
!
IF (ASSOCIATED(XT_ROOF)) DEALLOCATE(XT_ROOF)
IF (ASSOCIATED(XT_ROAD)) DEALLOCATE(XT_ROAD)
IF (ASSOCIATED(XT_WALL_A)) DEALLOCATE(XT_WALL_A)
IF (ASSOCIATED(XT_WALL_B)) DEALLOCATE(XT_WALL_B)
IF (ASSOCIATED(XAC_ROOF)) DEALLOCATE(XAC_ROOF)
IF (ASSOCIATED(XAC_ROAD)) DEALLOCATE(XAC_ROAD)
IF (ASSOCIATED(XAC_WALL)) DEALLOCATE(XAC_WALL)
IF (ASSOCIATED(XAC_TOP)) DEALLOCATE(XAC_TOP)
IF (ASSOCIATED(XAC_ROOF_WAT)) DEALLOCATE(XAC_ROOF_WAT)
IF (ASSOCIATED(XAC_ROAD_WAT)) DEALLOCATE(XAC_ROAD_WAT)
IF (ASSOCIATED(XQSAT_ROOF)) DEALLOCATE(XQSAT_ROOF)
IF (ASSOCIATED(XQSAT_ROAD)) DEALLOCATE(XQSAT_ROAD)
IF (ASSOCIATED(XDELT_ROOF)) DEALLOCATE(XDELT_ROOF)
IF (ASSOCIATED(XDELT_ROAD)) DEALLOCATE(XDELT_ROAD)
!-------------------------------------------------------------------------------------
!
IF(ASSOCIATED(XAC_ROOF    ))  DEALLOCATE(XAC_ROOF    )
IF(ASSOCIATED(XAC_ROAD    ))  DEALLOCATE(XAC_ROAD    )
IF(ASSOCIATED(XAC_WALL    ))  DEALLOCATE(XAC_WALL    )
IF(ASSOCIATED(XAC_TOP     ))  DEALLOCATE(XAC_TOP     )
IF(ASSOCIATED(XAC_ROOF_WAT))  DEALLOCATE(XAC_ROOF_WAT)
IF(ASSOCIATED(XAC_ROAD_WAT))  DEALLOCATE(XAC_ROAD_WAT)
IF(ASSOCIATED(XQSAT_ROOF  ))  DEALLOCATE(XQSAT_ROOF  )
IF(ASSOCIATED(XQSAT_ROAD  ))  DEALLOCATE(XQSAT_ROAD  )
IF(ASSOCIATED(XDELT_ROOF  ))  DEALLOCATE(XDELT_ROOF  )
IF(ASSOCIATED(XDELT_ROAD  ))  DEALLOCATE(XDELT_ROAD  )
!
!-------------------------------------------------------------------------------------
!
IF(ASSOCIATED(XDEP))      DEALLOCATE(XDEP)
IF(ASSOCIATED(CCH_NAMES)) DEALLOCATE(CCH_NAMES)
IF(ASSOCIATED(CSV))       DEALLOCATE(CSV)
!
!-------------------------------------------------------------------------------------
!
IF(ASSOCIATED(XPAR_Z0_TOWN    )) DEALLOCATE(XPAR_Z0_TOWN    )
IF(ASSOCIATED(XPAR_BLD        )) DEALLOCATE(XPAR_BLD        )
IF(ASSOCIATED(XPAR_ALB_ROOF   )) DEALLOCATE(XPAR_ALB_ROOF   )
IF(ASSOCIATED(XPAR_EMIS_ROOF  )) DEALLOCATE(XPAR_EMIS_ROOF  )
IF(ASSOCIATED(XPAR_HC_ROOF    )) DEALLOCATE(XPAR_HC_ROOF    )
IF(ASSOCIATED(XPAR_TC_ROOF    )) DEALLOCATE(XPAR_TC_ROOF    )
IF(ASSOCIATED(XPAR_D_ROOF     )) DEALLOCATE(XPAR_D_ROOF     )
IF(ASSOCIATED(XPAR_ALB_ROAD   )) DEALLOCATE(XPAR_ALB_ROAD   )
IF(ASSOCIATED(XPAR_EMIS_ROAD  )) DEALLOCATE(XPAR_EMIS_ROAD  )
IF(ASSOCIATED(XPAR_HC_ROAD    )) DEALLOCATE(XPAR_HC_ROAD    )
IF(ASSOCIATED(XPAR_TC_ROAD    )) DEALLOCATE(XPAR_TC_ROAD    )
IF(ASSOCIATED(XPAR_D_ROAD     )) DEALLOCATE(XPAR_D_ROAD     )
IF(ASSOCIATED(XPAR_ALB_WALL   )) DEALLOCATE(XPAR_ALB_WALL   )
IF(ASSOCIATED(XPAR_EMIS_WALL  )) DEALLOCATE(XPAR_EMIS_WALL  )
IF(ASSOCIATED(XPAR_HC_WALL    )) DEALLOCATE(XPAR_HC_WALL    )
IF(ASSOCIATED(XPAR_TC_WALL    )) DEALLOCATE(XPAR_TC_WALL    )
IF(ASSOCIATED(XPAR_D_WALL     )) DEALLOCATE(XPAR_D_WALL     )
IF(ASSOCIATED(XPAR_BLD_HEIGHT )) DEALLOCATE(XPAR_BLD_HEIGHT )
IF(ASSOCIATED(XPAR_WALL_O_HOR )) DEALLOCATE(XPAR_WALL_O_HOR )
IF(ASSOCIATED(XPAR_H_TRAFFIC  )) DEALLOCATE(XPAR_H_TRAFFIC  )
IF(ASSOCIATED(XPAR_LE_TRAFFIC )) DEALLOCATE(XPAR_LE_TRAFFIC )
IF(ASSOCIATED(XPAR_H_INDUSTRY )) DEALLOCATE(XPAR_H_INDUSTRY )
IF(ASSOCIATED(XPAR_LE_INDUSTRY)) DEALLOCATE(XPAR_LE_INDUSTRY)
IF(ASSOCIATED(XPAR_GARDEN     )) DEALLOCATE(XPAR_GARDEN     )
IF(ASSOCIATED(XPAR_ROAD_DIR   )) DEALLOCATE(XPAR_ROAD_DIR   )
IF(ASSOCIATED(NPAR_BLDTYPE    )) DEALLOCATE(NPAR_BLDTYPE    )
IF(ASSOCIATED(NPAR_BLD_AGE    )) DEALLOCATE(NPAR_BLD_AGE    )
IF(ASSOCIATED(NPAR_BLDCODE    )) DEALLOCATE(NPAR_BLDCODE    )
IF(ASSOCIATED(NPAR_USETYPE    )) DEALLOCATE(NPAR_USETYPE    )
!
!-------------------------------------------------------------------------------------
!
IF(ASSOCIATED(XHC_FLOOR   ))  DEALLOCATE(XHC_FLOOR   )
IF(ASSOCIATED(XTC_FLOOR   ))  DEALLOCATE(XTC_FLOOR   )
IF(ASSOCIATED(XD_FLOOR    ))  DEALLOCATE(XD_FLOOR    )
!
IF(ASSOCIATED(XF_WASTE_CAN))  DEALLOCATE(XF_WASTE_CAN)
IF(ASSOCIATED(XEFF_HEAT   ))  DEALLOCATE(XEFF_HEAT   )
IF(ASSOCIATED(XQIN        ))  DEALLOCATE(XQIN        )
IF(ASSOCIATED(XQIN_FRAD   ))  DEALLOCATE(XQIN_FRAD   )
IF(ASSOCIATED(XSHGC       ))  DEALLOCATE(XSHGC       )
IF(ASSOCIATED(XU_WIN      ))  DEALLOCATE(XU_WIN      )
IF(ASSOCIATED(XTRAN_WIN   ))  DEALLOCATE(XTRAN_WIN   )
IF(ASSOCIATED(XGR         ))  DEALLOCATE(XGR         )
IF(ASSOCIATED(XFLOOR_HEIGHT)) DEALLOCATE(XFLOOR_HEIGHT)
IF(ASSOCIATED(XINF        ))  DEALLOCATE(XINF        )
!
IF(ASSOCIATED(XQIN_FLAT   ))  DEALLOCATE(XQIN_FLAT   )
IF(ASSOCIATED(XHR_TARGET  ))  DEALLOCATE(XHR_TARGET  )
IF(ASSOCIATED(XV_VENT     ))  DEALLOCATE(XV_VENT     )
IF(ASSOCIATED(XCAP_SYS_HEAT)) DEALLOCATE(XCAP_SYS_HEAT)
IF(ASSOCIATED(XCAP_SYS_RAT))  DEALLOCATE(XCAP_SYS_RAT)
IF(ASSOCIATED(XT_ADP      ))  DEALLOCATE(XT_ADP      )
IF(ASSOCIATED(XM_SYS_RAT  ))  DEALLOCATE(XM_SYS_RAT  )
IF(ASSOCIATED(XCOP_RAT    ))  DEALLOCATE(XCOP_RAT    )
IF(ASSOCIATED(XT_SIZE_MAX ))  DEALLOCATE(XT_SIZE_MAX )
IF(ASSOCIATED(XT_SIZE_MIN ))  DEALLOCATE(XT_SIZE_MIN )
!
IF(ASSOCIATED(XABS_WIN    ))  DEALLOCATE(XABS_WIN    )
IF(ASSOCIATED(XALB_WIN    ))  DEALLOCATE(XALB_WIN    )
IF(ASSOCIATED(XUGG_WIN    ))  DEALLOCATE(XUGG_WIN    )
IF(ASSOCIATED(LSHAD_DAY   ))  DEALLOCATE(LSHAD_DAY   )
IF(ASSOCIATED(LNATVENT_NIGHT)) DEALLOCATE(LNATVENT_NIGHT)
IF(ASSOCIATED(CNATVENT    ))  DEALLOCATE(CNATVENT)
IF(ASSOCIATED(LSHADE      ))  DEALLOCATE(LSHADE)
IF(ASSOCIATED(XF_WATER_COND)) DEALLOCATE(XF_WATER_COND)
IF(ASSOCIATED(XSHGC_SH    ))  DEALLOCATE(XSHGC_SH)

IF(ASSOCIATED(XPAR_ROUGH_ROOF ))  DEALLOCATE(XPAR_ROUGH_ROOF)
IF(ASSOCIATED(XPAR_ROUGH_WALL ))  DEALLOCATE(XPAR_ROUGH_WALL)
IF(ASSOCIATED(XROUGH_ROOF ))  DEALLOCATE(XROUGH_ROOF)
IF(ASSOCIATED(XROUGH_WALL ))  DEALLOCATE(XROUGH_WALL)

IF(ASSOCIATED(XN_FLOOR ))  DEALLOCATE(XN_FLOOR)
IF(ASSOCIATED(XGLAZ_O_BLD ))  DEALLOCATE(XGLAZ_O_BLD)
IF(ASSOCIATED(XMASS_O_BLD ))  DEALLOCATE(XMASS_O_BLD)
IF(ASSOCIATED(XFLOOR_HW_RATIO ))  DEALLOCATE(XFLOOR_HW_RATIO)
IF(ASSOCIATED(XF_FLOOR_MASS ))  DEALLOCATE(XF_FLOOR_MASS)
IF(ASSOCIATED(XF_FLOOR_WALL ))  DEALLOCATE(XF_FLOOR_WALL)
IF(ASSOCIATED(XF_FLOOR_WIN ))  DEALLOCATE(XF_FLOOR_WIN)
IF(ASSOCIATED(XF_FLOOR_ROOF ))  DEALLOCATE(XF_FLOOR_ROOF)
IF(ASSOCIATED(XF_WALL_FLOOR ))  DEALLOCATE(XF_WALL_FLOOR)
IF(ASSOCIATED(XF_WALL_MASS ))  DEALLOCATE(XF_WALL_MASS)
IF(ASSOCIATED(XF_WALL_WIN ))  DEALLOCATE(XF_WALL_WIN)
IF(ASSOCIATED(XF_WIN_FLOOR ))  DEALLOCATE(XF_WIN_FLOOR)
IF(ASSOCIATED(XF_WIN_MASS ))  DEALLOCATE(XF_WIN_MASS)
IF(ASSOCIATED(XF_WIN_WALL ))  DEALLOCATE(XF_WIN_WALL)
IF(ASSOCIATED(XF_MASS_FLOOR ))  DEALLOCATE(XF_MASS_FLOOR)
IF(ASSOCIATED(XF_MASS_WALL ))  DEALLOCATE(XF_MASS_WALL)
IF(ASSOCIATED(XF_MASS_WIN ))  DEALLOCATE(XF_MASS_WIN)
IF(ASSOCIATED(XTI_BLD ))  DEALLOCATE(XTI_BLD)
IF(ASSOCIATED(XQI_BLD ))  DEALLOCATE(XQI_BLD)
IF(ASSOCIATED(XT_FLOOR ))  DEALLOCATE(XT_FLOOR)
IF(ASSOCIATED(XT_MASS ))  DEALLOCATE(XT_MASS)
IF(ASSOCIATED(XAUX_MAX ))  DEALLOCATE(XAUX_MAX)
IF(ASSOCIATED(XT_WIN2 ))  DEALLOCATE(XT_WIN2)
IF(ASSOCIATED(XT_WIN1 ))  DEALLOCATE(XT_WIN1)
!
!
IF (LHOOK) CALL DR_HOOK('DEALLOC_TEB_N',1,ZHOOK_HANDLE)
!
!-------------------------------------------------------------------------------------
!
END SUBROUTINE DEALLOC_TEB_n


