!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     ##################
MODULE MODN_FLAKE_n
!     ##################
!
!!****  *MODN_FLAKE_n* - declaration of namelist NAM_FLAKEn
!!
!!    PURPOSE
!!    -------
!       The purpose of this module is to specify  the namelist NAM_FLAKEn
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!       
!!    AUTHOR
!!    ------
!!	V. Masson    *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004                    
!-------------------------------------------------------------------------------
!
!*       0.   DECLARATIONS
!             ------------
!
USE MODD_DIAG_MISC_FLAKE_n, ONLY: &
           LWATER_PROFILE_n => LWATER_PROFILE, &
           XZWAT_PROFILE_n => XZWAT_PROFILE 

USE MODD_DIAG_FLAKE_n, ONLY: &
           XDIAG_TSTEP_n => XDIAG_TSTEP, &
           N2M_n => N2M, &
           L2M_MIN_ZS_n => L2M_MIN_ZS,  &!
           LSURF_BUDGET_n => LSURF_BUDGET, &
           LRAD_BUDGET_n => LRAD_BUDGET, &
           LSURF_BUDGETC_n => LSURF_BUDGETC, &
           LRESET_BUDGETC_n => LRESET_BUDGETC, &
           LCOEF_n => LCOEF, &
           LSURF_VARS_n => LSURF_VARS  
         
USE MODD_CH_WATFLUX_n, ONLY: &
           CCH_DRY_DEP_n => CCH_DRY_DEP  

Use MODD_FLAKE_n, ONLY: &
           XTSTEP_n => XTSTEP, &
           XOUT_TSTEP_n => XOUT_TSTEP, &
           LSEDIMENTS_n => LSEDIMENTS, &
           CFLK_FLUX_n => CFLK_FLUX, &
           CFLK_ALB_n => CFLK_ALB, &
           CSNOW_FLK_n => CSNOW_FLK, &
           XICHCE_n => XICHCE, &
           LPRECIP_n => LPRECIP, &
           LPWEBB_n => LPWEBB

!
         
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
REAL     :: XTSTEP
REAL     :: XOUT_TSTEP
REAL     :: XDIAG_TSTEP
INTEGER  :: N2M
LOGICAL  :: L2M_MIN_ZS
LOGICAL  :: LSURF_BUDGET
LOGICAL  :: LRAD_BUDGET
LOGICAL  :: LSURF_BUDGETC
LOGICAL  :: LRESET_BUDGETC
LOGICAL  :: LCOEF
LOGICAL  :: LSURF_VARS
 CHARACTER(LEN=6)  :: CCH_DRY_DEP
!
LOGICAL          :: LSEDIMENTS
 CHARACTER(LEN=3) :: CSNOW_FLK
 CHARACTER(LEN=5) :: CFLK_FLUX
 CHARACTER(LEN=4) :: CFLK_ALB
!
LOGICAL  :: LWATER_PROFILE
REAL,DIMENSION(100) :: XZWAT_PROFILE
!
REAL     :: XICHCE
LOGICAL  :: LPRECIP
LOGICAL  :: LPWEBB
!
NAMELIST/NAM_DIAG_FLAKEn/LWATER_PROFILE,XZWAT_PROFILE
NAMELIST/NAM_FLAKEn/LSEDIMENTS,CSNOW_FLK, CFLK_FLUX, CFLK_ALB,   &
                    XICHCE, LPRECIP, LPWEBB
NAMELIST/NAM_DIAG_SURFn/N2M,L2M_MIN_ZS,LSURF_BUDGET,LRAD_BUDGET, &
                          LSURF_BUDGETC,LRESET_BUDGETC,LCOEF,LSURF_VARS  
NAMELIST/NAM_CH_WATFLUXn/CCH_DRY_DEP
!
CONTAINS
!
SUBROUTINE INIT_NAM_FLAKEn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:INIT_NAM_FLAKEN',0,ZHOOK_HANDLE)
  XTSTEP=XTSTEP_n
  XOUT_TSTEP=XOUT_TSTEP_n
  LSEDIMENTS=LSEDIMENTS_n
  CFLK_FLUX=CFLK_FLUX_n
  CFLK_ALB=CFLK_ALB_n
  CSNOW_FLK=CSNOW_FLK_n
  XICHCE=XICHCE_n
  LPRECIP=LPRECIP_n
  LPWEBB=LPWEBB_n
IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:INIT_NAM_FLAKEN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_FLAKEn
!
SUBROUTINE UPDATE_NAM_FLAKEn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:UPDATE_NAM_FLAKEN',0,ZHOOK_HANDLE)
  XTSTEP_n = XOUT_TSTEP
  XOUT_TSTEP_n = XOUT_TSTEP
  LSEDIMENTS_n  =LSEDIMENTS
  CFLK_FLUX_n=CFLK_FLUX
  CFLK_ALB_n=CFLK_ALB
  CSNOW_FLK_n=CSNOW_FLK
  XICHCE_n=XICHCE
  LPRECIP_n=LPRECIP
  LPWEBB_n=LPWEBB
IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:UPDATE_NAM_FLAKEN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_FLAKEn
!
SUBROUTINE INIT_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:INIT_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP = XDIAG_TSTEP_n
  N2M = N2M_n
  L2M_MIN_ZS = L2M_MIN_ZS_n
  LSURF_BUDGET = LSURF_BUDGET_n
  LRAD_BUDGET = LRAD_BUDGET_n
  LSURF_BUDGETC = LSURF_BUDGETC_n
  LRESET_BUDGETC = LRESET_BUDGETC_n  
  LCOEF = LCOEF_n
  LSURF_VARS = LSURF_VARS_n
IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:INIT_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_SURFn

SUBROUTINE UPDATE_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:UPDATE_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP_n = XDIAG_TSTEP  
  N2M_n = N2M
  L2M_MIN_ZS_n = L2M_MIN_ZS
  LSURF_BUDGET_n = LSURF_BUDGET
  LRAD_BUDGET_n = LRAD_BUDGET 
  LSURF_BUDGETC_n = LSURF_BUDGETC
  LRESET_BUDGETC_n = LRESET_BUDGETC  
  LCOEF_n = LCOEF
  LSURF_VARS_n = LSURF_VARS
IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:UPDATE_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_SURFn
!
SUBROUTINE INIT_NAM_DIAG_FLAKEn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:INIT_NAM_DIAG_FLAKEN',0,ZHOOK_HANDLE)
  LWATER_PROFILE = LWATER_PROFILE_n
  XZWAT_PROFILE = XZWAT_PROFILE_n
IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:INIT_NAM_DIAG_FLAKEN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_FLAKEn

SUBROUTINE UPDATE_NAM_DIAG_FLAKEn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:UPDATE_NAM_DIAG_FLAKEN',0,ZHOOK_HANDLE)
  LWATER_PROFILE_n = LWATER_PROFILE
  XZWAT_PROFILE_n = XZWAT_PROFILE
IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:UPDATE_NAM_DIAG_FLAKEN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_FLAKEn

SUBROUTINE INIT_NAM_CH_WATFLUXn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:INIT_NAM_CH_WATFLUXN',0,ZHOOK_HANDLE)
  CCH_DRY_DEP = CCH_DRY_DEP_n
IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:INIT_NAM_CH_WATFLUXN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_WATFLUXn

SUBROUTINE UPDATE_NAM_CH_WATFLUXn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:UPDATE_NAM_CH_WATFLUXN',0,ZHOOK_HANDLE)
  CCH_DRY_DEP_n = CCH_DRY_DEP
IF (LHOOK) CALL DR_HOOK('MODN_FLAKE_N:UPDATE_NAM_CH_WATFLUXN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_WATFLUXn

END MODULE MODN_FLAKE_n
