!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!##################
MODULE MODN_TEB_VEG_n
!##################
!
!!****  *MODN_TEB_VEG_n* - declaration of namelist NAM_TEB_VEG_n
!!
!!    PURPOSE
!!    -------
!       The purpose of this module is to specify  the namelist NAM_TEB_VEG_n
!     which concern the surface configuration of one nested  model.
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!       
!!    AUTHOR
!!    ------
!!	V. Masson    *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004                    
!-------------------------------------------------------------------------------
!
!*       0.   DECLARATIONS
!             ------------
!
USE MODD_CH_TEB_n, ONLY:                   &
           LCH_BIO_FLUX_n => LCH_BIO_FLUX, &
           LCH_NO_FLUX_n => LCH_NO_FLUX,   &
           CCHEM_SURF_FILE_n => CCHEM_SURF_FILE  
USE MODD_TEB_VEG_n, ONLY:                  &
           CC1DRY_n => CC1DRY,             &
           CSCOND_n => CSCOND,             &
           CSOILFRZ_n => CSOILFRZ,         &
           CDIFSFCOND_n => CDIFSFCOND,     &
           CSNOWRES_n => CSNOWRES,         &
           CALBEDO_n => CALBEDO,           &
           CROUGH_n => CROUGH,             & 
           CCPSURF_n => CCPSURF,           &
           XTSTEP_n => XTSTEP,             &
           XCGMAX_n => XCGMAX,             &
           XCDRAG_n => XCDRAG,             &
           CRUNOFF_n => CRUNOFF,           &
           CTOPREG_n => CTOPREG,           &
           CKSAT_n => CKSAT,               &
           CSOC_n => CSOC,                 &           
           CRAIN_n => CRAIN,               &  
           CHORT_n => CHORT,               &
           LVEGUPD_n => LVEGUPD,           &           
           LCANOPY_DRAG_n => LCANOPY_DRAG
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
LOGICAL           :: LCH_BIO_FLUX
LOGICAL           :: LCH_NO_FLUX
LOGICAL           :: LTRIP
LOGICAL           :: LFLOOD
LOGICAL           :: LGLACIER
LOGICAL           :: LVEGUPD
LOGICAL           :: LCANOPY_DRAG
!
 CHARACTER(LEN=4)  :: CC1DRY
 CHARACTER(LEN=4)  :: CSCOND
 CHARACTER(LEN=3)  :: CSOILFRZ
 CHARACTER(LEN=4)  :: CDIFSFCOND
 CHARACTER(LEN=3)  :: CSNOWRES
 CHARACTER(LEN=4)  :: CALBEDO
 CHARACTER(LEN=4)  :: CROUGH
 CHARACTER(LEN=3)  :: CCPSURF
 CHARACTER(LEN=4)  :: CRUNOFF
 CHARACTER(LEN=3)  :: CTOPREG
 CHARACTER(LEN=3)  :: CKSAT
 CHARACTER(LEN=3)  :: CSOC
 CHARACTER(LEN=3)  :: CRAIN
 CHARACTER(LEN=3)  :: CHORT         
 CHARACTER(LEN=28) :: CCHEM_SURF_FILE
 CHARACTER(LEN=6)  :: CCH_DRY_DEP
!
REAL              :: XCGMAX
REAL              :: XTSTEP
REAL              :: XCDRAG
!
NAMELIST/NAM_ISBAn/CC1DRY,CSCOND,CSOILFRZ,CDIFSFCOND,CSNOWRES,CALBEDO,CROUGH,CCPSURF, &
                   XTSTEP,XCGMAX,XCDRAG,LGLACIER, LCANOPY_DRAG, LVEGUPD  
NAMELIST/NAM_SGH_ISBAn/CRUNOFF,CTOPREG,CKSAT,CSOC,CRAIN,CHORT,LTRIP,LFLOOD
NAMELIST/NAM_CH_CONTROLn/CCHEM_SURF_FILE
NAMELIST/NAM_CH_ISBAn/LCH_BIO_FLUX,CCH_DRY_DEP,LCH_NO_FLUX
!
CONTAINS
!
SUBROUTINE INIT_NAM_TEB_VEGn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:INIT_NAM_TEB_VEGN',0,ZHOOK_HANDLE)
  CC1DRY       = CC1DRY_n
  CSCOND       = CSCOND_n
  CSOILFRZ     = CSOILFRZ_n
  CDIFSFCOND   = CDIFSFCOND_n
  CSNOWRES     = CSNOWRES_n
  CALBEDO      = CALBEDO_n
  CROUGH       = CROUGH_n
  CCPSURF      = CCPSURF_n
  XTSTEP       = XTSTEP_n
  XCGMAX       = XCGMAX_n
  XCDRAG       = XCDRAG_n
  LVEGUPD      = LVEGUPD_n  
  LCANOPY_DRAG = LCANOPY_DRAG_n
IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:INIT_NAM_TEB_VEGN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_TEB_VEGn

SUBROUTINE UPDATE_NAM_TEB_VEGn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:UPDATE_NAM_TEB_VEGN',0,ZHOOK_HANDLE)
  CC1DRY_n       = CC1DRY
  CSCOND_n       = CSCOND
  CSOILFRZ_n     = CSOILFRZ
  CDIFSFCOND_n   = CDIFSFCOND
  CSNOWRES_n     = CSNOWRES
  CALBEDO_n      = CALBEDO
  CROUGH_n       = CROUGH
  CCPSURF_n      = CCPSURF
  XTSTEP_n       = XTSTEP
  XCGMAX_n       = XCGMAX
  XCDRAG_n       = XCDRAG
  LVEGUPD_n      = LVEGUPD
  LCANOPY_DRAG_n = LCANOPY_DRAG
IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:UPDATE_NAM_TEB_VEGN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_TEB_VEGn


SUBROUTINE INIT_NAM_SGH_TEB_VEGn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_TEB_VEG_N:INIT_NAM_SGH_TEB_VEGN',0,ZHOOK_HANDLE)
  CRUNOFF = CRUNOFF_n
  CTOPREG = CTOPREG_n
  CKSAT   = CKSAT_n
  CSOC    = CSOC_n
  CRAIN   = CRAIN_n
  CHORT   = CHORT_n
IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:INIT_NAM_SGH_TEB_VEGN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_SGH_TEB_VEGn

SUBROUTINE UPDATE_NAM_SGH_TEB_VEGn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:UPDATE_NAM_SGH_TEB_VEGN',0,ZHOOK_HANDLE)
  CRUNOFF_n  = CRUNOFF
  CTOPREG_n  = CTOPREG
  CKSAT_n    = CKSAT
  CSOC_n     = CSOC
  CRAIN_n    = CRAIN
  CHORT_n    = CHORT
IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:UPDATE_NAM_SGH_TEB_VEGN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_SGH_TEB_VEGn

SUBROUTINE INIT_NAM_CH_CONTROLn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:INIT_NAM_CH_CONTROLN',0,ZHOOK_HANDLE)
  CCHEM_SURF_FILE = CCHEM_SURF_FILE_n
IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:INIT_NAM_CH_CONTROLN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_CONTROLn

SUBROUTINE UPDATE_NAM_CH_CONTROLn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:UPDATE_NAM_CH_CONTROLN',0,ZHOOK_HANDLE)
  CCHEM_SURF_FILE_n = CCHEM_SURF_FILE
IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:UPDATE_NAM_CH_CONTROLN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_CONTROLn

SUBROUTINE INIT_NAM_CH_TEB_VEGn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:INIT_NAM_CH_TEB_VEGN',0,ZHOOK_HANDLE)
  LCH_BIO_FLUX = LCH_BIO_FLUX_n
  LCH_NO_FLUX  = LCH_NO_FLUX_n
IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:INIT_NAM_CH_TEB_VEGN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_TEB_VEGn

SUBROUTINE UPDATE_NAM_CH_TEB_VEGn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:UPDATE_NAM_CH_TEB_VEGN',0,ZHOOK_HANDLE)
  LCH_BIO_FLUX_n = LCH_BIO_FLUX
  LCH_NO_FLUX_n  = LCH_NO_FLUX
  IF (LHOOK) CALL DR_HOOK('MODN_TEB_VEG_N:UPDATE_NAM_CH_TEB_VEGN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_TEB_VEGn

END MODULE MODN_TEB_VEG_n
